#ifndef message_decoder_header
#define message_decoder_header
#include <string>
#include <fstream>
#include <iostream>

struct COLOR {unsigned char b,g,r,x;};	// Windows GDI expects 4bytes per color
using namespace std;

struct decoder_application_configuration
{

	string input_gif_file;
	string output_msg_file;
	string output_gif_file;
	int bits_interval;
	int bits_length_reduction;
};

struct frame_specification
{
	unsigned char* raster;
	unsigned char* encoded_gif;
	int encoded_gif_length;
	int screen_width;
	int screen_height;
	int BPP;
};

class message_decoder
{
private:

	// the set of input configurations
	unsigned char* raster; // the raster data of the message
	int next_pixel; //start from ordinal 0
	int total_nof_pixels;

	
	unsigned char* encoded_gif; // the embeded message
	int next_bit;//start from ordinal 0
	int CodeSize;
	int encoded_gif_length;

	int screen_width; // the width of the screen
	int screen_height; // the height of the screen
	int BPP; // bits per pixel
	int bits_interval; //
	int bits_length_reduction; //

	//for output
	string output_message_file;
	unsigned char* msg; 
	int number_of_bits_of_message; 
	int nofphrases;//statistics information
	int nofencodedphrases;

	//internal structure for holding the trie
	unsigned short *axon, *next; // arrays making up the stringtable
	unsigned char * pix;
	unsigned long cc;            // "clear code" which signals the clearing of the string table
	unsigned long eoi;           // "end-of-information code" which must be the last item of
	unsigned short freecode;     // next code to be added to the string table

	unsigned short* Prefix;
	short FirstEntry;
	short NextEntry;

	int phrase_counter;

public:
	message_decoder(decoder_application_configuration application_parameters, frame_specification frame_parameters);

	~message_decoder();
	int write_message();
	void iniroots();
	unsigned short findpixeloutlet(unsigned short headnode,unsigned char pixel);
	int decode_message();
	unsigned short next_phrase_nongreedy_from_file();
	int length_of_next_phrase_greedy();
	int length_of_next_phrase_nongreedy();
	void add_phrase_to_trie(unsigned short phrase);
};
#endif

