#ifndef __ENCODER_H
#define __ENCODER_H

#include <fstream>
#include <iostream>
#include <ctime> 
#include "somedatastructures.h"


using namespace std;
enum LZWoptions { Greedy, Nongreedy};

// the global variables that are defined in another file

// end of the global variables

unsigned short max(unsigned short a,unsigned short b);
unsigned short min(unsigned short a,unsigned short b);

class bitpacker
{
private:
	ofstream *binfile;
	unsigned char *buffer;  // holds the total buffer
	unsigned char *pos;     // points into buffer
	unsigned short need;    // used by addcodetobuffer(), see there
	void addcodetobuffer(unsigned long code, short n);
public:
	bool bad;            // to be checked after construction
	unsigned long byteswritten;  // Initialized with 0 upon construction, updated
	bitpacker(ofstream *bf);
	~bitpacker(void);
	void submit(unsigned long code, unsigned short n);
	void writeflush(void);
}; // class bitpacker

class gifcompressor
{
private:

	LZWoptions greedyness;
	unsigned char* randombits;// used to hold the random bits
	bitpacker *bp;       // object that does the packing and writing of the
	unsigned long nofdata;       // number of pixels in the data stream
	unsigned long width;         // width of bitmap in pixels
	unsigned long height;        // height of bitmap in pixels
	unsigned long curordinal;    // ordinal number of next pixel to be encoded
	unsigned char pixel;         // next pixel to be encoded
	unsigned char *data;         // points to the first byte of the input data stream
	unsigned short datadepth;    // length of the input data in bits. Possible values
	unsigned short nbits;        // current length of compression codes in bits
	unsigned short *axon, *next; // arrays making up the stringtable
	unsigned char *pix;          // dito
	unsigned long cc;            // "clear code" which signals the clearing of the string table
	unsigned long eoi;           // "end-of-information code" which must be the last item of
	unsigned short freecode;     // next code to be added to the string table
	int length_of_the_encoding_phrase_greater_than;
	int every_nof_phrases;
	int phrase_counter;
	void flushstringtable(void);
	void iniroots(void);
	unsigned long weiter(void);
	unsigned long weiter_nongreedy();
	unsigned short findpixeloutlet(unsigned short headnode,unsigned char pixel);
	int nofphrases;
	int nofencodedphrases;
	int nofpixels;
public:
	gifcompressor(LZWoptions option,encoder_application_specification command_line_parameters);
	~gifcompressor(void);
	unsigned long get_nofphrases();
	unsigned long get_nofencodedphrases();
	unsigned long writedatablocks(ofstream *bf,unsigned char *pixel,unsigned long nof,unsigned long wi,unsigned short ds);
	unsigned long write_back_message(ofstream* messagefile);
}; // class gifcompressor
#endif 
