#! /usr/bin/env python
import sys
import re
import math
import commands


#length_of_encoding_phrases=[i+1 for i in range(20)]
length_of_encoding_phrases=[0,1,2]

#every_number_phrases=[i+1 for i in range(20)]
every_number_phrases=[sys.argv[2]]
#every_number_phrases=[1]

giffiles=['giffile/airplane','giffile/baboon','giffile/couple','giffile/girl','giffile/lena','giffile/peppers']
#giffiles=['giffile/airplane']

command_output_re=re.compile(r"Screen Width:(\d*)\nScreen Height:(\d*)\nbits per pixel:(\d*)\nafter ====================\nno of phrases:(\d*)\nno of encoded phrases:(\d*)\nno of bytes written:(\d*)\nnumber of frames:(\d*)\ntotal number of phrases greedy:(\d*)\nScreen Width:(\d*)\nScreen Height:(\d*)\nbits per pixel:(\d*)\nafter ====================\nno of phrases:(\d*)\nno of encoded phrases:(\d*)\nno of bytes written:(\d*)\nnumber of frames:(\d*)\ntotal number of phrases nongreedy:(\d*)\ntotal number of encoded phrases:(\d*)")
file_size_re=re.compile(r"csgrads *(\d+)")

status_per_file =["Width" , "Height", "BPP","Size","\#phrs","compr ratio"]
status_per_file_per_setting = ["Size","\#phrs","\#coding phrs", "mssg length" , "compr ratio","compr loss1","compr loss2"]

result=[ [ [ 0 for i in range(len(status_per_file))] , [ [[0 for i in range( len(status_per_file_per_setting ))] for i in range(len(every_number_phrases)) ] for i in range(len(length_of_encoding_phrases)) ] ] for i in range(len(giffiles)) ]

print length_of_encoding_phrases
print every_number_phrases
print giffiles

for one_row in result:
	print one_row

def get_command (picture, length_of_phrases, every_nof_phrases):
	return "relaxedlzw.exe "+picture+" "+length_of_phrases+" "+every_nof_phrases


def write_report (_result, _giffiles, _length_of_encoding_phrases, _every_number_phrases,  _status_per_file, _status_per_file_per_setting):
	f=open(sys.argv[1],'w')
	f.write("\\documentclass[a3paper,7pt]{article}\n\\oddsidemargin -0.9in \n\\evensidemargin -0.9in\n\\topmargin -1in\n\\headheight 0in\n\\begin{document}\n")
	_every_number_phrases_index=-1
	for para1 in _every_number_phrases:
		_every_number_phrases_index=_every_number_phrases_index+1
		_length_of_encoding_phrases_index=-1
		for para2 in _length_of_encoding_phrases:
			_length_of_encoding_phrases_index=_length_of_encoding_phrases_index+1
			f.write("\t\\begin{table}\n\t\t\\small\n\t\t\\begin{center}\n")
			#write the begin{tabular} flow control
			f.write("\t\t\\begin{tabular}{|c||")
			for i in _status_per_file:
				f.write('c|')
			f.write('|')
			for j in _status_per_file_per_setting:
				f.write('c|')
			f.write('|')
			f.write('}\n\t\t\t\\hline\n\t\t\t')
			#write the header of the files
			f.write("&\\multicolumn{"+str(len(_status_per_file))+"}{c||}{original file}")
			f.write('&\\multicolumn{'+str(len(_status_per_file_per_setting))+'}{c||}{new file with parameter '+str(para2)+'}')
			f.write('\\\\\n')
			f.write('\t\t\t\\cline{2-'+str(1+len(_status_per_file)+(len(_status_per_file_per_setting)))+'}\n')
			f.write('\t\t\t')
			for i in _status_per_file:
				f.write('&\\parbox{0.37in}{'+ i +'}')
			for j in _status_per_file_per_setting:
				f.write('&\\parbox{0.37in}{'+ j+'}')			
			f.write('\\\\\n\t\t\t\\hline\\hline\n')
				
			_giffiles_index=-1
			for i in _giffiles:
				_giffiles_index=_giffiles_index+1
				f.write('\t\t\t'+i[8:]+'.gif')
					
				_status_per_file_index=-1
				for j in _status_per_file:
					_status_per_file_index=_status_per_file_index+1
					f.write('&'+str(_result[_giffiles_index][0][_status_per_file_index]))
				_status_per_file_per_setting_index=-1
				for l in _status_per_file_per_setting:
					_status_per_file_per_setting_index=_status_per_file_per_setting_index+1
					f.write('&'+str(_result[_giffiles_index][1][_length_of_encoding_phrases_index][_every_number_phrases_index][_status_per_file_per_setting_index]))
							
				f.write('\\\\\n\t\t\t\\hline\n')
			f.write('\t\t\\end{tabular}\n')
			f.write("\t\t\\end{center}\n\t\t\\caption{every "+ str(para1) + " phrases \& phrase length greater than"+ str(para2) +"}\n\t\\end{table}\n")
	f.write("\\end{document}\n")
	



giffile_index=-1
length_of_encoding_phrase_index=-1
every_number_phrase_index=-1


for filepath in giffiles:
	giffile_index=giffile_index + 1
	length_of_encoding_phrase_index=-1
	every_number_phrase_index=-1
	for i in length_of_encoding_phrases:
		every_number_phrase_index=-1
		length_of_encoding_phrase_index=length_of_encoding_phrase_index+1
		for j in every_number_phrases:
			every_number_phrase_index=every_number_phrase_index+1
			command_line = get_command(filepath, str(i), str(j))
			print command_line
			command_output=commands.getoutput(command_line)
			print command_output
			output_status=command_output_re.match(command_output)
#1  screen width:
#2  screen height:
#3  bits per pixel:
#4  no of phrases for the original file
#12 no of phrases for the new file
#13 no of message encoding phrases

			screen_width=int(output_status.group(1))
			screen_height=int(output_status.group(2))
			bits_per_pixel=int(output_status.group(3))
			nof_phrases_original_file=int(output_status.group(4))
			nof_phrases_new_file=int(output_status.group(12))
			nof_message_encoding_phrases=int(output_status.group(13))
			original_file_compression_ratio=str(float((screen_width*screen_height))/nof_phrases_original_file)[0:4]
			new_file_compression_ratio=str(float((screen_width*screen_height))/nof_phrases_new_file)[0:4]
			
			original_file_size_str=commands.getoutput("ls -l "+filepath+".greedy.gif")
			#print original_file_size_str
			original_file_size=int(file_size_re.search(original_file_size_str).group(1))
			new_file_size_str=commands.getoutput("ls -l "+filepath+".nongreedy.gif")
			#print new_file_size_str
			new_file_size=int(file_size_re.search(new_file_size_str).group(1))
			message_file_size_str=commands.getoutput("ls -l "+filepath+".nongreedy.gif.message")
			#print message_file_size_str
			message_file_size=int(file_size_re.search(message_file_size_str).group(1))
			file_size_increase_by=new_file_size - original_file_size
			compression_lose_by=new_file_size - (original_file_size+message_file_size)

			result[giffile_index][0][0]=screen_width
			result[giffile_index][0][1]=screen_height
			result[giffile_index][0][2]=bits_per_pixel
			result[giffile_index][0][3]=original_file_size
			result[giffile_index][0][4]=nof_phrases_original_file
			result[giffile_index][0][5]=original_file_compression_ratio
			result[giffile_index][1][length_of_encoding_phrase_index][every_number_phrase_index][0]=new_file_size
			result[giffile_index][1][length_of_encoding_phrase_index][every_number_phrase_index][1]=nof_phrases_new_file
			result[giffile_index][1][length_of_encoding_phrase_index][every_number_phrase_index][2]=nof_message_encoding_phrases
			result[giffile_index][1][length_of_encoding_phrase_index][every_number_phrase_index][3]=message_file_size
			result[giffile_index][1][length_of_encoding_phrase_index][every_number_phrase_index][4]=new_file_compression_ratio
			result[giffile_index][1][length_of_encoding_phrase_index][every_number_phrase_index][5]=file_size_increase_by
			result[giffile_index][1][length_of_encoding_phrase_index][every_number_phrase_index][6]=compression_lose_by

for one_row in result:
	print one_row

write_report(result, giffiles, length_of_encoding_phrases,every_number_phrases,status_per_file,status_per_file_per_setting)





